# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from dataspeed_ulc_msgs/UlcReport.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import std_msgs.msg

class UlcReport(genpy.Message):
  _md5sum = "98357b292a53c2df86976a69fa57fc0d"
  _type = "dataspeed_ulc_msgs/UlcReport"
  _has_header = True  # flag to mark the presence of a Header object
  _full_text = """std_msgs/Header header
bool pedals_enabled
bool steering_enabled
bool speed_preempted
bool steering_preempted
bool override_latched
bool timeout

uint8 YAW_RATE_MODE=0
uint8 CURVATURE_MODE=1
uint8 steering_mode

uint8 LOOSE_TRACKING_MODE=0
uint8 TIGHT_TRACKING_MODE=1
uint8 tracking_mode

float32 speed_ref
float32 speed_meas
float32 accel_ref
float32 accel_meas
float32 max_steering_angle
float32 max_steering_vel

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
string frame_id
"""
  # Pseudo-constants
  YAW_RATE_MODE = 0
  CURVATURE_MODE = 1
  LOOSE_TRACKING_MODE = 0
  TIGHT_TRACKING_MODE = 1

  __slots__ = ['header','pedals_enabled','steering_enabled','speed_preempted','steering_preempted','override_latched','timeout','steering_mode','tracking_mode','speed_ref','speed_meas','accel_ref','accel_meas','max_steering_angle','max_steering_vel']
  _slot_types = ['std_msgs/Header','bool','bool','bool','bool','bool','bool','uint8','uint8','float32','float32','float32','float32','float32','float32']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       header,pedals_enabled,steering_enabled,speed_preempted,steering_preempted,override_latched,timeout,steering_mode,tracking_mode,speed_ref,speed_meas,accel_ref,accel_meas,max_steering_angle,max_steering_vel

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(UlcReport, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.pedals_enabled is None:
        self.pedals_enabled = False
      if self.steering_enabled is None:
        self.steering_enabled = False
      if self.speed_preempted is None:
        self.speed_preempted = False
      if self.steering_preempted is None:
        self.steering_preempted = False
      if self.override_latched is None:
        self.override_latched = False
      if self.timeout is None:
        self.timeout = False
      if self.steering_mode is None:
        self.steering_mode = 0
      if self.tracking_mode is None:
        self.tracking_mode = 0
      if self.speed_ref is None:
        self.speed_ref = 0.
      if self.speed_meas is None:
        self.speed_meas = 0.
      if self.accel_ref is None:
        self.accel_ref = 0.
      if self.accel_meas is None:
        self.accel_meas = 0.
      if self.max_steering_angle is None:
        self.max_steering_angle = 0.
      if self.max_steering_vel is None:
        self.max_steering_vel = 0.
    else:
      self.header = std_msgs.msg.Header()
      self.pedals_enabled = False
      self.steering_enabled = False
      self.speed_preempted = False
      self.steering_preempted = False
      self.override_latched = False
      self.timeout = False
      self.steering_mode = 0
      self.tracking_mode = 0
      self.speed_ref = 0.
      self.speed_meas = 0.
      self.accel_ref = 0.
      self.accel_meas = 0.
      self.max_steering_angle = 0.
      self.max_steering_vel = 0.

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_get_struct_8B6f().pack(_x.pedals_enabled, _x.steering_enabled, _x.speed_preempted, _x.steering_preempted, _x.override_latched, _x.timeout, _x.steering_mode, _x.tracking_mode, _x.speed_ref, _x.speed_meas, _x.accel_ref, _x.accel_meas, _x.max_steering_angle, _x.max_steering_vel))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 32
      (_x.pedals_enabled, _x.steering_enabled, _x.speed_preempted, _x.steering_preempted, _x.override_latched, _x.timeout, _x.steering_mode, _x.tracking_mode, _x.speed_ref, _x.speed_meas, _x.accel_ref, _x.accel_meas, _x.max_steering_angle, _x.max_steering_vel,) = _get_struct_8B6f().unpack(str[start:end])
      self.pedals_enabled = bool(self.pedals_enabled)
      self.steering_enabled = bool(self.steering_enabled)
      self.speed_preempted = bool(self.speed_preempted)
      self.steering_preempted = bool(self.steering_preempted)
      self.override_latched = bool(self.override_latched)
      self.timeout = bool(self.timeout)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_get_struct_8B6f().pack(_x.pedals_enabled, _x.steering_enabled, _x.speed_preempted, _x.steering_preempted, _x.override_latched, _x.timeout, _x.steering_mode, _x.tracking_mode, _x.speed_ref, _x.speed_meas, _x.accel_ref, _x.accel_meas, _x.max_steering_angle, _x.max_steering_vel))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 32
      (_x.pedals_enabled, _x.steering_enabled, _x.speed_preempted, _x.steering_preempted, _x.override_latched, _x.timeout, _x.steering_mode, _x.tracking_mode, _x.speed_ref, _x.speed_meas, _x.accel_ref, _x.accel_meas, _x.max_steering_angle, _x.max_steering_vel,) = _get_struct_8B6f().unpack(str[start:end])
      self.pedals_enabled = bool(self.pedals_enabled)
      self.steering_enabled = bool(self.steering_enabled)
      self.speed_preempted = bool(self.speed_preempted)
      self.steering_preempted = bool(self.steering_preempted)
      self.override_latched = bool(self.override_latched)
      self.timeout = bool(self.timeout)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_3I = None
def _get_struct_3I():
    global _struct_3I
    if _struct_3I is None:
        _struct_3I = struct.Struct("<3I")
    return _struct_3I
_struct_8B6f = None
def _get_struct_8B6f():
    global _struct_8B6f
    if _struct_8B6f is None:
        _struct_8B6f = struct.Struct("<8B6f")
    return _struct_8B6f
